
# 
# Ingmar Visser & Maarten Speekenbrink, march 2008
# 

# 
# NOW FIX SOME PARAMETERS
# 

# now constrain the initial state probs to be 0 and 1 
# also constrain the guessing probs to be 0.5 and 0.5 

# set the starting values of this model to the optimized 
# values of the previously fitted model to speed optimization

pars <- c(unlist(getpars(mod1)))
 
# set some to other values, ie the ones that we want to constrain

pars[2]=+Inf
pars[14]=0

mod <- setpars(mod,pars) 

# fix some parameters

free <- c(0,0,rep(c(0,1),4),1,1,0,0,1,1,0,1)

mod2 <- fit(mod,fixed=!free)

llratio(mod1,mod2)

cat("Test 2: likelihood ratio not significant, hence mod2 better than mod1.\n")


# NOW ADD SOME GENERAL LINEAR CONSTRAINTS

# set the starting values of this model to the optimized 
# values of the previously fitted model to speed optimization

pars <- c(unlist(getpars(mod2)))
mod <- setpars(mod,pars)

# start with fixed and free parameters
conpat <- c(0,0,rep(c(0,1),4),1,1,0,0,1,1,0,1)
# constrain the beta's on the transition parameters to be equal
conpat[4] <- conpat[8] <- 2
conpat[6] <- conpat[10] <- 3

mod3 <- fit(mod,equal=conpat)

llratio(mod2,mod3)

cat("Test3: log Likelihood ratio significant, constraints not tenable.")





